;Paralleler Interface-Bus mit Adressenausgabe ber Port1  (BUS87.ASM)
;und mit CS-Signal fr Adresse 124...127
.org 000
Bus            call    Empf19          ;Empfangen
               mov     R0,A            ;Adresse
               outl    P1,A            ;Ausgabe Port 1
               jb7     Lesen
               add     A,#84h          ;Adresse >= 124?
               jnc     Sonst
               call    Empf19
               anl     P2,#0DFh        ;CS-Signal
               movX    @R0,A           ;Ausgabe Daten
               jmp     Bus
Sonst          call    Empf19          ;Adresse < 124
               orl     P2,#20h         ;kein CS-Signal
               movX    @R0,A
               jmp     Bus
Lesen          add     A,#4            ;Adresse >= 124?
               jnc     SonstL
               anl     P2,#0DFh        ;CS-Signal
               movX    A,@R0           ;Daten lesen
               call    Send19          ;Daten senden
               jmp     Bus
SonstL         orl     P2,#20h         ;kein CS-Signal
               movX    A,@R0           ;Daten lesen
               orl     P2,#20h         ;Daten senden
               call    Send19
               jmp     Bus

               ;Senden mit 19200 Baud bei 4MHz ber P27
Send19         mov     R5,#8           ;RS232-Ausgabe
               anl     P2,#7Fh         ;P27 = 0, Startbit
               mov     R6,#3
Sch1           djnz    R6,Sch1         ;Warteschleife Startbit
Sp1            nop                     ;Zeitausgleich 1 Zyklus
               rrc     A               ;Datenbit in C schieben
               jc      Sp2             ;wenn C = 0,
               anl     P2,#7Fh         ;dann P27 = 0
               jmp     Sp3
Sp2            orl     P2,#80h         ;sonst P27 = 1
               nop                     ;Zeitausgleich 2 Zyklen
               nop
Sp3            mov     R6,#1
Sch2           djnz    R6,Sch2         ;Warteschleife Datenbit
               djnz    R5,Sp1          ;8 mal wiederholen
               nop                     ;Zeitausgleich 4 Zyklen
               nop
               nop
               nop
               orl     P2,#80h         ;P27 = 1, Stopbit
               mov     R6,#3
Sch3           djnz    R6,Sch3         ;Warteschleife Stopbit
               ret

               ;Empfangen mit 19200 Baud bei 4MHz ber P26
Empf19         in      A,P2            ;RS232-Empfnger
               anl     A,#40h          ;P26 testen
               jnz     Empf19          ;Schleife bis P26 = 0
               mov     R6,#3
Sch4           djnz    R6,Sch4         ;Warteschleife Startbit
               mov     R5,#8
Sp4            in      A,P2
               nop                     ;Zeitausgleich 1 Zyklus
               rlc     A               ;Bit von P26 in C schieben
               rlc     A
               xch     A,R7            ;Datenbyte in a laden
               rrc     A               ;C in A schieben
               xch     A,R7            ;Datenbyte zurckschreiben
               mov     R6,#1
Sch5           djnz    R6,Sch5         ;Warteschleife Datenbit
               djnz    R5,Sp4          ;8 mal wiederholen
               mov     A,R7            ;Datenbyte in A laden
               ret
               nop
.end
